> ## Documentation Index
> Fetch the complete documentation index at: https://www.c1.ai/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List

> List directories.



## OpenAPI

````yaml https://spec.speakeasy.com/conductor-one/conductorone/my-source-with-code-samples get /api/v1/directories
openapi: 3.1.0
info:
  description: The C1 API is a HTTP API for managing C1 resources.
  title: C1 API
  version: 0.1.0-alpha
servers:
  - description: The C1 API server for the current tenant.
    url: https://{tenantDomain}.conductor.one
    variables:
      tenantDomain:
        default: example
        description: The domain of the tenant to use for this request.
security:
  - bearerAuth: []
    oauth: []
paths:
  /api/v1/directories:
    get:
      tags:
        - Directory
      summary: List
      description: List directories.
      operationId: c1.api.directory.v1.DirectoryService.List
      parameters:
        - in: query
          name: page_size
          schema:
            description: The pageSize field.
            format: int32
            readOnly: false
            type: integer
        - in: query
          name: page_token
          schema:
            description: The pageToken field.
            readOnly: false
            type: string
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/c1.api.directory.v1.DirectoryServiceListResponse
          description: >-
            The DirectoryServiceListResponse message contains a list of results
            and a nextPageToken if applicable.
      x-codeSamples:
        - lang: go
          label: List
          source: "package main\n\nimport(\n\t\"context\"\n\t\"github.com/conductorone/conductorone-sdk-go/pkg/models/shared\"\n\tconductoronesdkgo \"github.com/conductorone/conductorone-sdk-go\"\n\t\"github.com/conductorone/conductorone-sdk-go/pkg/models/operations\"\n\t\"log\"\n)\n\nfunc main() {\n    ctx := context.Background()\n\n    s := conductoronesdkgo.New(\n        conductoronesdkgo.WithSecurity(shared.Security{\n            BearerAuth: \"<YOUR_BEARER_TOKEN_HERE>\",\n            Oauth: \"<YOUR_OAUTH_HERE>\",\n        }),\n    )\n\n    res, err := s.Directory.List(ctx, operations.C1APIDirectoryV1DirectoryServiceListRequest{})\n    if err != nil {\n        log.Fatal(err)\n    }\n    if res.DirectoryServiceListResponse != nil {\n        // handle response\n    }\n}"
        - lang: typescript
          label: Typescript (SDK)
          source: >-
            import { ConductoroneSDKTypescript } from
            "conductorone-sdk-typescript";


            const conductoroneSDKTypescript = new ConductoroneSDKTypescript({
              security: {
                bearerAuth: "<YOUR_BEARER_TOKEN_HERE>",
                oauth: "<YOUR_OAUTH_HERE>",
              },
            });


            async function run() {
              const result = await conductoroneSDKTypescript.directory.list();

              console.log(result);
            }


            run();
components:
  schemas:
    c1.api.directory.v1.DirectoryServiceListResponse:
      description: >-
        The DirectoryServiceListResponse message contains a list of results and
        a nextPageToken if applicable.
      properties:
        expanded:
          description: >-
            The nextPageToken is shown for the next page if the number of
            results is larger than the max page size.
             The server returns one page of results and the nextPageToken until all results are retreived.
             To retrieve the next page, use the same request and append a pageToken field with the value of nextPageToken shown on the previous page.
          items:
            additionalProperties: true
            description: >-
              Contains an arbitrary serialized message along with a @type that
              describes the type of the serialized message.
            properties:
              '@type':
                description: The type of the serialized message.
                type: string
            readOnly: false
            type: object
          nullable: true
          readOnly: false
          type: array
        list:
          description: >-
            The list of results containing up to X results, where X is the page
            size defined in the request.
          items:
            $ref: '#/components/schemas/c1.api.directory.v1.DirectoryView'
          nullable: true
          readOnly: false
          type: array
        nextPageToken:
          description: List of serialized related objects.
          readOnly: false
          type: string
      title: Directory Service List Response
      type: object
      x-speakeasy-name-override: DirectoryServiceListResponse
    c1.api.directory.v1.DirectoryView:
      description: >-
        The directory view contains a directory and an app_path which is a
        JSONPATH set to the location in the expand mask that the expanded app
        will live if requested by the expander.
      properties:
        appPath:
          description: >-
            JSONPATH expression indicating the location of the App object in the
            array.
          readOnly: false
          type: string
        directory:
          $ref: '#/components/schemas/c1.api.directory.v1.Directory'
      title: Directory View
      type: object
      x-speakeasy-name-override: DirectoryView
    c1.api.directory.v1.Directory:
      description: >
        This object indicates that an app is also a directory.


        This message contains a oneof named account_filter. Only a single field
        of the following list may be set at a time:
          - all
          - celExpression
      properties:
        all:
          $ref: '#/components/schemas/c1.api.directory.v1.DirectoryAccountFilterAll'
        appId:
          description: The ID of the app associated with the directory.
          readOnly: true
          type: string
        celExpression:
          $ref: '#/components/schemas/c1.api.directory.v1.DirectoryAccountFilterCel'
        createdAt:
          format: date-time
          readOnly: true
          type: string
        deletedAt:
          format: date-time
          readOnly: true
          type: string
        mergeConfig:
          $ref: '#/components/schemas/c1.api.directory.v1.DirectoryMergeConfig'
        updatedAt:
          format: date-time
          readOnly: true
          type: string
      title: Directory
      type: object
      x-speakeasy-name-override: Directory
    c1.api.directory.v1.DirectoryAccountFilterAll:
      description: The DirectoryAccountFilterAll message.
      nullable: true
      title: Directory Account Filter All
      type: object
      x-speakeasy-name-override: DirectoryAccountFilterAll
    c1.api.directory.v1.DirectoryAccountFilterCel:
      description: The DirectoryAccountFilterCel message.
      nullable: true
      properties:
        expression:
          description: The expression field.
          readOnly: false
          type: string
      title: Directory Account Filter Cel
      type: object
      x-speakeasy-name-override: DirectoryAccountFilterCel
    c1.api.directory.v1.DirectoryMergeConfig:
      description: >-
        DirectoryMergeConfig configures how AppUsers from this directory are
        matched to C1 Users.
      properties:
        matchCases:
          description: Ordered list of match cases evaluated in sequence. First match wins.
          items:
            $ref: '#/components/schemas/c1.api.directory.v1.DirectoryMergeMatchCase'
          nullable: true
          readOnly: false
          type: array
      title: Directory Merge Config
      type: object
      x-speakeasy-name-override: DirectoryMergeConfig
    c1.api.directory.v1.DirectoryMergeMatchCase:
      description: >-
        DirectoryMergeMatchCase defines a pair of CEL key extractors for
        matching.
      properties:
        appUserKeyCel:
          description: CEL expression evaluated against an AppUser to produce match key(s).
          readOnly: false
          type: string
        userKeyCel:
          description: CEL expression evaluated against a User to produce match key(s).
          readOnly: false
          type: string
      title: Directory Merge Match Case
      type: object
      x-speakeasy-name-override: DirectoryMergeMatchCase
  securitySchemes:
    bearerAuth:
      scheme: bearer
      type: http
    oauth:
      description: >-
        This API uses OAuth2 with the Client Credential flow.

        Client Credentials must be sent in the BODY, not the headers.

        For an example of how to implement this, refer to the
        [c1TokenSource.Token()](https://github.com/ConductorOne/conductorone-sdk-go/blob/3375fe7c0126d17e7ec4e711693dee7b791023aa/token_source.go#L101-L187)
        function.
      flows:
        clientCredentials:
          scopes: {}
          tokenUrl: /auth/v1/token
      type: oauth2

````